package name.panitz.ki
trait DepthSearch[M] extends SearchTree[M] {

  def depthSearch():List[M]=generalSearch((x,y)=>y:::x)

def generalGraphSearch(insertNew:Insert[M]):List[M]={
    val allreadyExpanded = new java.util.HashSet/*[SearchTree[M]]*/()
    generalSearch(
      (xs,ys)=>{
        val newNodes= 
          for (val y<-ys;!(allreadyExpanded contains y)) yield y
        for (val y<-newNodes) allreadyExpanded add y   
        insertNew(newNodes,xs)}
     )
  }

  def depthSearchGraph():List[M]=generalGraphSearch((x,y)=>y:::x)

  def depthSearch(depth:Int):List[M]=
    generalSearch((xs,ys)=>{
      val newNodes=for (val y<-ys;y._1.length < depth) yield y
      newNodes:::xs}
    )

  def deepening():List[M]={
    var result:List[M]=null;
    var depth=0;
    while (result==null){
      result=depthSearch(depth)
      depth=depth+1
    }
    result
  }
}

