package name.panitz.ki
trait GameTree[M] extends SearchTree[M]{

  type Player = Byte

  def getCurrentPlayer():Player

  def otherPlayer(player:Player):Player

  def move(i:M):GameTree[M]

  def evalState(player:Player):Int

  def minMaxSearch()=minMaxValue(getCurrentPlayer)

  def minMaxValue(forPlayer:Player):Pair[Int,M]={

    if (terminalState) Pair(evalState(forPlayer),null:M)

    else{
      val doMax = getCurrentPlayer==forPlayer

      val exVal=if(doMax) Integer.MIN_VALUE else Integer.MAX_VALUE 
      def comp(x:Int,y:Int)=if (doMax) (x>y) else (x<y) 

      ((for (val i:M <- moves().elements) 
       yield Pair(move(i).minMaxValue(forPlayer)._1,i))
       .foldLeft(Pair(exVal,null:M))
                ((x,y)=>if (comp (x._1,y._1)) x else y))
    }
  }

  def move():GameTree[M] = move(minMaxSearch()._2)
}

