package name.panitz.ki
trait InformedSearch[M] extends DepthSearch[M] {
  def estimatedGoalDistance():Int;

  def greedyBestFirst():List[M]={
    def le=(x:Path[M],y:Path[M])
      =>(x._2.asInstanceOf[InformedSearch[M]].estimatedGoalDistance
         <= 
        y._2.asInstanceOf[InformedSearch[M]].estimatedGoalDistance)

    generalGraphSearch((xs,ys)=>insertAll(le,xs,ys))}

  type LE[A]=(A,A)=>Boolean
  def insert[A]:(LE[A],A,List[A])=>List[A]=(le,x,ys)=>{
     var temp:List[A]=Nil
     var rest=ys
     while (!rest.isEmpty&& !le(x,rest.head)){
       temp=rest.head :: temp
       rest=rest.tail
     }
     temp.reverse  ::: x :: rest
  }

  def insertAll[A]:(LE[A],List[A],List[A])=>List[A]=(le,xs,ys)=>{
    if (ys.isEmpty) xs
    else insertAll(le,insert(le,ys.head,xs),ys.tail)
  }

  def pathDistance(xs:List[M]):Int;

  def aStar():List[M]={
    def le=(x:Path[M],y:Path[M])
     =>(pathDistance(x._1)
        +x._2.asInstanceOf[InformedSearch[M]].estimatedGoalDistance
         <= 
        pathDistance(y._1)
        +y._2.asInstanceOf[InformedSearch[M]].estimatedGoalDistance)

    generalGraphSearch((xs,ys)=>insertAll(le,xs,ys))}
}

