package name.panitz.ki
object Resolution{
  import scala.collection.mutable.Set
  import scala.collection.mutable.HashSet
  type Klausel=Set[Formel]

  def resolvable(xs:Klausel,ys:Klausel)=
    xs.exists((x)=>ys.exists((y)=>y.negated==x))

  def resolve(xs:Klausel,ys:Klausel)={
    val result=new HashSet[Formel]()
    for (val x<-xs.elements;!ys.exists((y)=>y==x.negated)) result+=x
    for (val y<-ys.elements;!xs.exists((x)=>y==x.negated)) result+=y
    result
  }

  def resolution(xsP:List[Klausel])={    
    var xs=xsP
    var zs=xsP
    while (!zs.isEmpty && !zs.exists((x)=>x.size==0)){
      val ks=
       for (val x<-xs;val y<-zs;resolvable(x,y)) yield resolve(x,y)
       
      zs=ks.toList
      xs= xs ::: zs
    }
    xs
  }

  def proof(a:Formel):List[Set[Formel]]=proof(List(),a)
  def proof(ms:List[Formel],a:Formel):List[Set[Formel]]={
    var clauses=List[Set[Formel]]()      
    for (val m<-ms) clauses = m.cnf ::: clauses
    clauses = Not(a).cnf ::: clauses
    resolution(clauses)
  }
}

