package name.panitz.ki
import javax.swing.{_}
class SlidePanel(p:InformedSlide) extends JPanel{
  var puzzle=p
  val chipSize=50

  addMouseListener(new Mousy())
  add (new BoardPanel())

  val button=new JButton("depth search")
  add(button)

  import java.awt.event.{_}
  button.addActionListener(new ActionListener(){
    override def actionPerformed(ev:ActionEvent)=
      performMoves (()=>puzzle depthSearch 10)
  })

  val button2=new JButton("breadth search")
  add(button2)
  button2.addActionListener(new ActionListener(){
    override def actionPerformed(ev:ActionEvent)=
      performMoves (puzzle.breadthFirst)
  })

  val button3=new JButton("deepening")
  add(button3)
  button3.addActionListener(new ActionListener(){
    override def actionPerformed(ev:ActionEvent)=
      performMoves (puzzle.deepening)
  })

  val button4=new JButton("A*")
  add(button4)
  button4.addActionListener(new ActionListener(){
    override def actionPerformed(ev:ActionEvent)=
      performMoves (puzzle.aStar)
  })

  def performMoves(ms:()=>List[Direction.Value])={
    import name.panitz.swing.SwingWorker
    val worker = new SwingWorker() {
     override def construct():Object= { 
      for (val m<-ms()) {
        Thread.sleep(500);puzzle=puzzle.move(m);repaint()
      }
      puzzle
     }
    }
    worker.start()
  }

  class BoardPanel extends JPanel{
   override def getPreferredSize():java.awt.Dimension
    =new java.awt.Dimension(chipSize*puzzle.SIZE,chipSize*puzzle.SIZE)

   override def  paintComponent(g:java.awt.Graphics)={
    import java.awt.Color.{_}
    super.paintComponent( g)
    for (val r<-Iterator.range(0,puzzle.SIZE)){      
      for (val c<-Iterator.range(0,puzzle.SIZE)){
	if (puzzle.field(c)(r)==0){
          g setColor WHITE
          g.fillRect(r*chipSize,c*chipSize,chipSize,chipSize)
	}else{
          g setColor RED
          g.fillRect(r*chipSize,c*chipSize,chipSize,chipSize)
          g setColor BLACK
          g.drawString(puzzle.field(c)(r).toString
                      ,r*chipSize+chipSize/2,c*chipSize+chipSize/2)
	}
      }
    }
    g setColor DARK_GRAY
    for (val r<-Iterator.range(0,puzzle.SIZE+1))
      g.fillRect(0,r*chipSize-5/2,chipSize*puzzle.SIZE,5)
    for (val c<-Iterator.range(0,puzzle.SIZE+1))
      g.fillRect(c*chipSize-5/2,0,5,chipSize*puzzle.SIZE)
   }
  }

  class Mousy extends MouseAdapter{
    override def mouseClicked(ev:MouseEvent)={
      val x = ev.getX()/chipSize
      val y = ev.getY()/chipSize

      if (x>0&& ((puzzle.field(y)(x-1))==0))
        puzzle=puzzle.move(Direction.Left)
      else if (x<puzzle.SIZE-1&&puzzle.field(y)(x+1)==0) {
        puzzle=puzzle.move(Direction.Right)
      }
      else if (y>0&&puzzle.field(y-1)(x)==0)
        puzzle=puzzle.move(Direction.Up)
      else if (y<puzzle.SIZE-1&&puzzle.field(y+1)(x)==0)
        puzzle=puzzle.move(Direction.Down)
      repaint()
    }
  }
}

