package name.panitz.ki
case class SlidePuzzle(val SIZE:Int)
    extends SearchTree[Direction.Value] {

  var r=0
  var c=0

  var field = new Array[Array[Int]](SIZE)
  for (val i<-Iterator.range(0,SIZE)) field(i)=new Array[Int](SIZE)
  for (val i<-Iterator.range(0,SIZE*SIZE)) field(i/SIZE)(i%SIZE)=i

  def this(that:SlidePuzzle)={
    this(that.SIZE)
    copyFromThat(that)
  }

  def copyFromThat(that:SlidePuzzle)={
    for(val i<-Iterator.range(0,SIZE);val j<-Iterator.range(0,SIZE))
      field(j)(i)=that.field(j)(i)
    r=that.r
    c=that.c
  }

import Direction.{_};
  def moves():List[Direction.Value]={
    var result=List[Direction.Value]()
    if (r>0)      result=Down::result
    if (r<SIZE-1) result=Up::result
    if (c>0)      result=Right::result
    if (c<SIZE-1) result=Left::result
    result
  }

  def terminalState():Boolean={
    var result=true;
    for (val r<-Iterator.range(0,SIZE)
        ;val c<-Iterator.range(0,SIZE)
        ;result&&
         {result= !(field(r)(c)/SIZE!=r || field(r)(c)%SIZE!=c) 
         ;result}){}
    result
  }

  def move(m:Direction.Value):SlidePuzzle={
    val res=new SlidePuzzle(this)
    res.move(m,res)
  }

  def move(m:Direction.Value,res:SlidePuzzle)={
    m match {
     case Up => 
      res.field(r)(c)=field(r+1)(c)
      res.field(r+1)(c)=0
      res.r=r+1
     case Down=>
      res.field(r)(c)=field(r-1)(c)
      res.field(r-1)(c)=0
      res.r=r-1
     case Left=> 
      res.field(r)(c)=field(r)(c+1)
      res.field(r)(c+1)=0
      res.c=c+1
     case Right=>
      res.field(r)(c)=field(r)(c-1)
      res.field(r)(c-1)=0
      res.c=c-1
    }
    res
  }

  override def toString()={
    val result = new StringBuffer()
    for (val j<-Iterator.range(0,SIZE)){
      for (val i<-Iterator.range(0,SIZE))
       result append ("|"+(if (0==field(j)(i)) " "else field(j)(i)))
      result append ("|\n")
    }
    result.toString()
  }

  override def equals(other:Any):Boolean={
    var result=true;
    var that=other.asInstanceOf[SlidePuzzle]
    for (val r<-Iterator.range(0,SIZE)
        ;val c<-Iterator.range(0,SIZE)
        ;result
        ){result=result&&this.field(r)(c)==that.field(r)(c)}
    result
  }
}

