package name.panitz.ki
class Sudoku extends DepthSearch[Tuple3[Int,Int,Int]] {
  type Move=Tuple3[Int,Int,Int]

  val field:Array[Array[Int]]=new Array[Array[Int]](9)
  for (val i<-Iterator.range(0,9))field(i)=new Array[Int](9)

  def this(that:Sudoku)={
    this()
    for (val r<-Iterator.range(0,9);val c<-Iterator.range(0,9))
      field(r)(c)=that.field(r)(c)
  }

  def moves():List[Move]={
   val freeFields=
    for (val r<-Iterator.range(0,9)
        ;val c<-Iterator.range(0,9)
        ;field(r)(c)==0) yield Pair(r,c)

   if (freeFields.hasNext){
     val Pair(r,c)=freeFields.next
     (for (val n<-Iterator.range(1,10) 
          ;fullFillsConstraints(n,r,c)
          ) yield {Tuple(r,c,n)}).toList
   }else List()
  }

  def fullFillsConstraints(n:Int,r:Int,c:Int)=
    (  fullFillsRow(n,r)
     &&fullFillsColumn(n,c)
     &&fullFillsSquare(n,(r-r%3),(c-c%3)))

  def fullFillsRow(newVal:Int,r:Int)={
    val values=newVal ::
      (for (val c<-Iterator.range(0,9);val n=field(r)(c);n!=0)
        yield n).toList
    values.length==values.removeDuplicates.length
  }

  def fullFillsColumn(newVal:Int,c:Int)={
    val values=newVal ::
      (for (val r<-Iterator.range(0,9);val n=field(r)(c);n!=0)
        yield n).toList
    values.length==values.removeDuplicates.length
  }

  def fullFillsSquare(newVal:Int,r:Int,c:Int)={
    var values=List[Int](newVal)
    for (val i<-Iterator.range(0,3)
        ;val j<-Iterator.range(0,3)
        ;val n=field(r+i)(c+j)
        ;n!=0)
      values=n::values
    values.length==values.removeDuplicates.length
  }

  def move(m:Move):Sudoku={
    val result=new Sudoku(this)
    val Tuple3(r,c,n)=m
    result.field(r)(c)=n
    result
  }

  def terminalState():Boolean=
   (for (val r<-Iterator.range(0,9);val c<-Iterator.range(0,9)
        ;val n=field(r)(c)) yield n).forall((x)=>x!=0)

  override def toString()={
    val result = new StringBuffer()
    for (val j<-Iterator.range(0,9)){
      for (val i<-Iterator.range(0,9))
       result append ("|"+(if (0==field(j)(i)) " "else field(j)(i)))
      result append ("|\n")
    }
    result.toString()
  }
}

