package name.panitz.ki
class TicTacToe() extends GameTree[Pair[Int,Int]]{
  val EMPTY     :Player= 0
  val PLAYER_ONE:Player= 1
  val PLAYER_TWO:Player= 2

  val C:Int = 3
  val R:Int = 3

  var field = new Array[Array[Player]](C)
  var currentPlayer = PLAYER_ONE

  for (val i <- Iterator.range(0,C)){
    field(i)=new Array[Player](R)
    for (val j <- Iterator.range(0,R))
      field(i)(j)=EMPTY
  }

  def this(other:TicTacToe)={
    this()
    for (val i<-Iterator.range(0,R);val j<-Iterator.range(0,C))
      field(j)(i)=other.field(j)(i)
  }

  def getCurrentPlayer()=currentPlayer
  def otherPlayer(player:Player):Player
   =if (player==PLAYER_ONE)PLAYER_TWO else PLAYER_ONE

  def move(i:Pair[int,int]):GameTree[Pair[int,int]]={
    val result=new TicTacToe(this)
    result.field(i._1)(i._2)=getCurrentPlayer
    result.currentPlayer = otherPlayer(currentPlayer) 
    result
  }

  def moves():List[Pair[Int,Int]]=
    (for(val i<-Iterator.range(0,R);val j<-Iterator.range(0,C)
        ;field(j)(i)==EMPTY) yield Pair(j,i)).toList

  def terminalState():boolean =
    wins(PLAYER_ONE)||wins(PLAYER_TWO)||boardFull()

  def boardFull():boolean =
   ((for (val i<-Iterator.range(0,R);val j<-Iterator.range(0,C)) 
    yield field(i)(j)).forall((x)=>x!=EMPTY))

  def evalState(player:Player)
   =if (wins(player)) 1 else if(wins(otherPlayer(player))) -1 else 0

  def wins(player:Player)=
   (field(0)(0)==player&&field(0)(1)==player&&field(0)(2)==player)||
   (field(1)(0)==player&&field(1)(1)==player&&field(1)(2)==player)||
   (field(2)(0)==player&&field(2)(1)==player&&field(2)(2)==player)||
   (field(0)(0)==player&&field(1)(0)==player&&field(2)(0)==player)||
   (field(0)(1)==player&&field(1)(1)==player&&field(2)(1)==player)||
   (field(0)(2)==player&&field(1)(2)==player&&field(2)(2)==player)||
   (field(0)(0)==player&&field(1)(1)==player&&field(2)(2)==player)||
   (field(2)(0)==player&&field(1)(1)==player&&field(0)(2)==player)

  override def toString()={
    val result = new StringBuffer()
    for (val i<-Iterator.range(0,R)){
      for (val j<-Iterator.range(0,C))
         result append ("|"+field(j)(R-i-1))
      result append ("|"+(R-i-1)+"\n")
    }
    for (val j<-Iterator.range(0,C)) result append "--"
    result append "--\n"
    for (val j<-Iterator.range(0,C))result append ("|"+j)
    result append "|\n"
    result.toString()
  }
}

